/**********************************************************************
 * (C) Copyright SYSCOM COMPUTER ENGINEERING CO. 2003.
 *
 **********************************************************************/

#ifndef _XTT_HEADER
#define _XTT_HEADER

// include files for odbc
#include "odbc.h"
#include "dmxtt.h"

class XTTEnv;
class ErrorBuffer;

class XTT_EXPORT XTT
{
public:

  // -----------------------------------------------------------------------
  //  Constructors and Destructor
  // -----------------------------------------------------------------------
  XTT();
  ~XTT();

  // Setter methods
  int setDatabaseConnection( const HDBC ConnectionHandle );
  int setDatabaseConnection( const char * connectionStr );

  void setXtt( const char *XttFileName );
  void setXtt( const char * xttValuePtr, int szXttValue );

  void setOutputXml( const char *XmlFileName );
  void setOutputXml( char * xmlValuePtr, int szXmlValue );

  void setParameters( const char * value );
  void setParameters( const char * value, int szValue );

  void setGenXMLHeader( bool stat );

  // get error message
  const char * getError();
  // get only append error message
  // it's an undocument method which will be used by stored procedure.
  const char * getAppendMsg();

  // Execute methods
  int run();
  int run (   const char * connectionStr,
              const char *XttFileName,
              const char *XmlFileName );
  int run (   const char * connectionStr,
              const char *xttValuePtr, int szXttValue,
              char *xmlValuePtr, int szXmlValue);

private:

  // private methods
  int closeConnection();    // close previous connection
                            // if it's established in XMLTransfer.

  void * pheap;
  HDBC hdbc;

  const char * parameters;
  const char * xttFile;
  const char * xmlFile;
  const char * xttValue;
  char * xmlValue;
  char error[512];
  ErrorBuffer * err;

  long rc;

  int szXttValue;
  int szXmlValue;

  bool doHeader;
  const char * connectionStr;
  bool prepared;

  XTTEnv * xttenv;
};

#endif // _XTT_HEADER
